import 'package:flutter/foundation.dart';

class Response {
  final Map<String, dynamic> result;
  final String body;
  final ResponseState state;
  final num statusCode;

  Response(this.body, this.statusCode,
      {@required this.state, @required this.result});

  operator [](String key) {
    if (result != null && result.containsKey(key)) return result[key];
    return null;
  }

  @override
  String toString() {
    return {
      "result": result,
      "body": body,
      "state": state,
      "statusCode": statusCode
    }.toString();
  }
}

enum ResponseState { SUCCESS, ERROR, UNEXPECTED, NETWORK_CONNECTION }

extension StateExtension on ResponseState {
  int get value {
    switch (this) {
      case ResponseState.NETWORK_CONNECTION:
        return 2;
      case ResponseState.SUCCESS:
        return 1;
      case ResponseState.ERROR:
        return 0;
      case ResponseState.UNEXPECTED:
      default:
        return -1;
    }
  }
//  void talk() {
//    print(this.value);
//  }
}
